Dim Shared As Integer lowf,highf,equaltype=1
Dim Shared As Single lowg,midg,highg
Dim Shared As Integer lowf0,highf0,equaltype0=1
Dim Shared As Single lowg0,midg0,highg0
Dim Shared As Integer lowf1,highf1,equaltype1=1
Dim Shared As Single lowg1,midg1,highg1
lowf=200
highf=8000
lowg=2.0
midg=1.0
highg=1.2

  ' Filter #0 (bass band)
Dim Shared es_bf   As Single        ' Frequency/100000.0
Dim Shared es_f0p0 As single        ' Poles ...
Dim Shared es_f0p1 As single       
Dim Shared es_f0p2 As Single
Dim Shared es_f0p3 As single 

  ' Filter #1 (Low band)
Dim Shared es_lf   As Single        ' Frequency/100000.0
Dim Shared es_f1p0 As single        ' Poles ...
Dim Shared es_f1p1 As single       
Dim Shared es_f1p2 As Single
Dim Shared es_f1p3 As single 

  ' Filter #2 (High band)
Dim Shared es_hf   As Single        ' Frequency/100000.0
Dim Shared es_f2p0 As single        ' Poles ...
Dim Shared es_f2p1 As single       
Dim Shared es_f2p2 As Single
Dim Shared es_f2p3 As single 

  ' Sample history buffer
Dim Shared es_s1 As single       ' Sample data minus 1
Dim Shared es_s2 As single       '                   2
Dim Shared es_s3 As single       '                   3

  ' Gain Controls
Dim Shared es_lowg As Single        ' low  gain
Dim Shared es_midg As Single        ' mid  gain
Dim Shared es_highg As Single       ' high gain
 

  ' Filter #0 (bass band)
Dim Shared es2_bf   As Single        ' Frequency/100000.0
Dim Shared es2_f0p0 As single        ' Poles ...
Dim Shared es2_f0p1 As single       
Dim Shared es2_f0p2 As Single
Dim Shared es2_f0p3 As single 

  ' Filter #1 (Low band)
Dim Shared es2_lf   As Single        ' Frequency/100000.0
Dim Shared es2_f1p0 As single        ' Poles ...
Dim Shared es2_f1p1 As single       
Dim Shared es2_f1p2 As Single
Dim Shared es2_f1p3 As single 

  ' Filter #2 (High band)
Dim Shared es2_hf   As Single        ' Frequency/100000.0
Dim Shared es2_f2p0 As single        ' Poles ...
Dim Shared es2_f2p1 As single       
Dim Shared es2_f2p2 As Single
Dim Shared es2_f2p3 As single 

  ' Sample history buffer
Dim Shared es2_s1 As single       ' Sample data minus 1
Dim Shared es2_s2 As single       '                   2
Dim Shared es2_s3 As single       '                   3

  ' Gain Controls
Dim Shared es2_lowg As Single        ' low  gain
Dim Shared es2_midg As Single        ' mid  gain
Dim Shared es2_highg As Single       ' high gain

function equcalcul1 (byval sample as single) as single
  ' Locals
  dim as single  l,m,h      ' Low / Mid / High - Sample Values
  dim as single  g

  ' Filter #1 (lowpass)
  g=(es_lf)
  es_f1p0  += ((sample - es_f1p0+1e-5)*g)

  l = (es_f1p0)

  ' Filter #2 (highpass)
  g=(es_hf)
  es_f2p0  += ((sample - es_f2p0+1e-5)*g)

  h = (sample - es_f2p0)

  ' Calculate midrange (signal - (low + high))
  m = (sample) - (h + l)

  ' Scale, Combine and store
  l         *= ((es_lowg))
  m         *= ((es_midg))
  h         *= ((es_highg))


  return (l+m+h) 
end function 
function equcalcul2 (byval sample as single) as single
  ' Locals
  dim as single  l,m,h      ' Low / Mid / High - Sample Values
  dim as single  g

  ' Filter #1 (lowpass)
  g=(es_lf)
  es_f1p0  += ((sample - es_f1p0+1e-5)*g)
  es_f1p1  += ((es_f1p0 - es_f1p1)*g)

  l = (es_f1p1)

  ' Filter #2 (highpass)
  g=(es_hf)
  es_f2p0  += ((sample - es_f2p0+1e-5)*g)
  es_f2p1  += ((es_f2p0 - es_f2p1)*g)

  h = (es_s1 - es_f2p1)

  ' Calculate midrange (signal - (low + high))
  m = (es_s1) - (h + l)

  ' Scale, Combine and store
  l         *= ((es_lowg))
  m         *= ((es_midg))
  h         *= ((es_highg))

  ' Shuffle history buffer
  es_s1   = sample                

  return (l+m+h) 
end Function
function equcalcul3 (byval sample as single) as single
  ' Locals
  dim as single  l,m,h      ' Low / Mid / High - Sample Values
  dim as single  g

  ' Filter #1 (lowpass)
  g=(es_lf)
  es_f1p0  += ((sample - es_f1p0+1e-5)*g)
  es_f1p1  += ((es_f1p0 - es_f1p1)*g)
  es_f1p2  += ((es_f1p1 - es_f1p2)*g)

  l = (es_f1p2)

  ' Filter #2 (highpass)
  g=(es_hf)
  es_f2p0  += ((sample - es_f2p0+1e-5)*g)
  es_f2p1  += ((es_f2p0 - es_f2p1)*g)
  es_f2p2  += ((es_f2p1 - es_f2p2)*g)

  h = (es_s2 - es_f2p2)

  ' Calculate midrange (signal - (low + high))
  m = (es_s2) - (h + l)

  ' Scale, Combine and store
  l         *= ((es_lowg))
  m         *= ((es_midg))
  h         *= ((es_highg))

  ' Shuffle history buffer
  es_s2   = es_s1
  es_s1   = sample                

  return (l+m+h) 
end Function
function equcalcul4 (byval sample as single) as single
  ' Locals
  dim as single  l,m,h      ' Low / Mid / High - Sample Values
  dim as single  g

  ' Filter #1 (lowpass)
  g=(es_lf)
  es_f1p0  += ((sample - es_f1p0+1e-5)*g)
  es_f1p1  += ((es_f1p0 - es_f1p1)*g)
  es_f1p2  += ((es_f1p1 - es_f1p2)*g)
  es_f1p3  += ((es_f1p2 - es_f1p3)*g)

  l = (es_f1p3)

  ' Filter #2 (highpass)
  g=(es_hf)
  es_f2p0  += ((sample - es_f2p0+1e-5)*g)
  es_f2p1  += ((es_f2p0 - es_f2p1)*g)
  es_f2p2  += ((es_f2p1 - es_f2p2)*g)
  es_f2p3  += ((es_f2p2 - es_f2p3)*g)

  h = (es_s3 - es_f2p3)

  ' Calculate midrange (signal - (low + high))
  m = (es_s3) - (h + l)

  ' Scale, Combine and store
  l         *= ((es_lowg))
  m         *= ((es_midg))
  h         *= ((es_highg))

  ' Shuffle history buffer
  es_s3   = es_s2
  es_s2   = es_s1
  es_s1   = sample                

  return (l+m+h) 
end Function

function equcalcul1_2 (byval sample as single) as single
  ' Locals
  dim as single  l,m,h      ' Low / Mid / High - Sample Values
  dim as single  g

  ' Filter #1 (lowpass)
  g=(es2_lf)
  es2_f1p0  += ((sample - es2_f1p0+1e-5)*g)

  l = (es2_f1p0)

  ' Filter #2 (highpass)
  g=(es2_hf)
  es2_f2p0  += ((sample - es2_f2p0+1e-5)*g)

  h = (sample - es2_f2p0)

  ' Calculate midrange (signal - (low + high))
  m = (sample) - (h + l)

  ' Scale, Combine and store
  l         *= ((es2_lowg))
  m         *= ((es2_midg))
  h         *= ((es2_highg))


  return (l+m+h) 
end function 
function equcalcul2_2 (byval sample as single) as single
  ' Locals
  dim as single  l,m,h      ' Low / Mid / High - Sample Values
  dim as single  g

  ' Filter #1 (lowpass)
  g=(es2_lf)
  es2_f1p0  += ((sample - es2_f1p0+1e-5)*g)
  es2_f1p1  += ((es2_f1p0 - es2_f1p1)*g)

  l = (es2_f1p1)

  ' Filter #2 (highpass)
  g=(es2_hf)
  es2_f2p0  += ((sample - es2_f2p0+1e-5)*g)
  es2_f2p1  += ((es2_f2p0 - es2_f2p1)*g)

  h = (es2_s1 - es2_f2p1)

  ' Calculate midrange (signal - (low + high))
  m = (es2_s1) - (h + l)

  ' Scale, Combine and store
  l         *= ((es2_lowg))
  m         *= ((es2_midg))
  h         *= ((es2_highg))

  ' Shuffle history buffer
  es2_s1   = sample                

  return (l+m+h) 
end Function
function equcalcul3_2 (byval sample as single) as single
  ' Locals
  dim as single  l,m,h      ' Low / Mid / High - Sample Values
  dim as single  g

  ' Filter #1 (lowpass)
  g=(es2_lf)
  es2_f1p0  += ((sample - es2_f1p0+1e-5)*g)
  es2_f1p1  += ((es2_f1p0 - es2_f1p1)*g)
  es2_f1p2  += ((es2_f1p1 - es2_f1p2)*g)

  l = (es2_f1p2)

  ' Filter #2 (highpass)
  g=(es2_hf)
  es2_f2p0  += ((sample - es2_f2p0+1e-5)*g)
  es2_f2p1  += ((es2_f2p0 - es2_f2p1)*g)
  es2_f2p2  += ((es2_f2p1 - es2_f2p2)*g)

  h = (es2_s2 - es2_f2p2)

  ' Calculate midrange (signal - (low + high))
  m = (es2_s2) - (h + l)

  ' Scale, Combine and store
  l         *= ((es2_lowg))
  m         *= ((es2_midg))
  h         *= ((es2_highg))

  ' Shuffle history buffer
  es2_s2   = es2_s1
  es2_s1   = sample                

  return (l+m+h) 
end Function
function equcalcul4_2 (byval sample as single) as single
  ' Locals
  dim as single  l,m,h      ' Low / Mid / High - Sample Values
  dim as single  g

  ' Filter #1 (lowpass)
  g=(es2_lf)
  es2_f1p0  += ((sample - es2_f1p0+1e-5)*g)
  es2_f1p1  += ((es2_f1p0 - es2_f1p1)*g)
  es2_f1p2  += ((es2_f1p1 - es2_f1p2)*g)
  es2_f1p3  += ((es2_f1p2 - es2_f1p3)*g)

  l = (es2_f1p3)

  ' Filter #2 (highpass)
  g=(es2_hf)
  es2_f2p0  += ((sample - es2_f2p0+1e-5)*g)
  es2_f2p1  += ((es2_f2p0 - es2_f2p1)*g)
  es2_f2p2  += ((es2_f2p1 - es2_f2p2)*g)
  es2_f2p3  += ((es2_f2p2 - es2_f2p3)*g)

  h = (es2_s3 - es2_f2p3)

  ' Calculate midrange (signal - (low + high))
  m = (es2_s3) - (h + l)

  ' Scale, Combine and store
  l         *= ((es2_lowg))
  m         *= ((es2_midg))
  h         *= ((es2_highg))

  ' Shuffle history buffer
  es2_s3   = es2_s2
  es2_s2   = es2_s1
  es2_s1   = sample                

  return (l+m+h) 
end Function
Sub resetequalizer()
Dim As Integer mixfreq
mixfreq=fbs_get_plugrate()
If mixfreq<4000 Then mixfreq=4000
If mixfreq>100000 Then mixfreq=100000
'mixfreq=44100
es_lf =  2 * sin(3.1416 * (lowf / mixfreq))
es_hf =  2 * sin(3.1416 * (highf / mixfreq))
es2_lf = 2 * sin(3.1416 * (lowf / mixfreq))
es2_hf = 2 * sin(3.1416 * (highf / mixfreq))
  es_lowg=lowg
  es_midg=midg
  es_highg=highg	
  es2_lowg=lowg
  es2_midg=midg
  es2_highg=highg	

  es_f0p0 =1e-5
  es_f0p1 =1e-5
  es_f0p2 =1e-5
  es_f0p3 =1e-5
  es_f1p0 =1e-5
  es_f1p1 =1e-5
  es_f1p2 =1e-5
  es_f1p3 =1e-5
  es_f2p0 =1e-5
  es_f2p1 =1e-5
  es_f2p2 =1e-5
  es_f2p3 =1e-5
  es_s1 =1e-5
  es_s2 =1e-5
  es_s3 =1e-5

  es2_f0p0 =1e-5
  es2_f0p1 =1e-5
  es2_f0p2 =1e-5
  es2_f0p3 =1e-5
  es2_f1p0 =1e-5
  es2_f1p1 =1e-5
  es2_f1p2 =1e-5
  es2_f1p3 =1e-5
  es2_f2p0 =1e-5
  es2_f2p1 =1e-5
  es2_f2p2 =1e-5
  es2_f2p3 =1e-5
  es2_s1 =1e-5
  es2_s2 =1e-5
  es2_s3 =1e-5
  
end sub 

